package com.adaptionsoft.games.uglytrivia.infrastructure

import com.adaptionsoft.games.uglytrivia.core.Category
import com.adaptionsoft.games.uglytrivia.core.Question
import com.adaptionsoft.games.uglytrivia.core.Questions

class AutogeneratedQuestions : Questions {
    private val popQuestions = generateQuestion()
    private val scienceQuestions = generateQuestion()
    private val sportsQuestions = generateQuestion()
    private val rockQuestions = generateQuestion()

    private fun generateQuestion() = generateSequence(0) { it + 1 }.iterator()

    override fun fromCategory(category: Category) =
        Question(askQuestion(category))

    override fun askQuestion(category: Category) = when (category) {
        Category.POP -> "Pop Question ${popQuestions.next()}"
        Category.SCIENCE -> "Science Question ${scienceQuestions.next()}"
        Category.SPORTS -> "Sports Question ${sportsQuestions.next()}"
        Category.ROCK -> "Rock Question ${rockQuestions.next()}"
    }

}
